/*---------------------------------------------------------------------
Data: 15/05/2011
Autor: Antoni Garca Burgueo
Base de Dades: Oracle 10g
Descripci: 

	Script de Creaci dels Esquemes:
		BD_POSTVENDA: Taules Base de Dades Postvenda i Procediments
		DW_POSTVENDA: Magatzem de Dades Postvenda
		ETL_POSTVENDA: Procediments ETL
----------------------------------------------------------------------*/ 


---------------------------------
-- ESQUEMA BD_POSTVENDA
---------------------------------
-- DROP USER BD_POSTVENDA CASCADE;
CREATE USER BD_POSTVENDA
IDENTIFIED BY POSTVENDA_BD
DEFAULT TABLESPACE users
QUOTA UNLIMITED ON users
TEMPORARY TABLESPACE temp;


---------------------------------
-- ESQUEMA DW_POSTVENDA
---------------------------------
-- DROP USER DW_POSTVENDA CASCADE;
CREATE USER DW_POSTVENDA
IDENTIFIED BY POSTVENDA_DW
DEFAULT TABLESPACE users
QUOTA UNLIMITED ON users
TEMPORARY TABLESPACE temp;


---------------------------------
-- ESQUEMA ETL_POSTVENDA 
---------------------------------
-- DROP USER ETL_POSTVENDA CASCADE;
CREATE USER ETL_POSTVENDA
IDENTIFIED BY POSTVENDA_ETL
DEFAULT TABLESPACE users
QUOTA UNLIMITED ON users
TEMPORARY TABLESPACE temp;


----------------------------------------
-- ASSIGNACI DE PERMISOS ALS ESQUEMES
----------------------------------------

GRANT CREATE SESSION, CREATE TABLE, CREATE VIEW,
      CREATE PROCEDURE, CREATE TRIGGER, CREATE SEQUENCE, 
      UPDATE ANY TABLE, INSERT ANY TABLE, SELECT ANY TABLE
      TO BD_POSTVENDA, DW_POSTVENDA, ETL_POSTVENDA;
COMMIT;      

