/*
Data: 15/05/2011
Autor: Antoni Garca Burgueo
Base de Dades: Oracle 10g
Descripci: Scripts per les seqncies i els triggers dels IDs autoincrementals
*/


-- Schema DW_POSTVENDA
ALTER SESSION SET CURRENT_SCHEMA = BD_POSTVENDA;

COMMIT;


------------------
--Actuacions
------------------
CREATE SEQUENCE seq_Actuacions 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdActuacio
BEFORE INSERT ON Actuacions
FOR EACH ROW
BEGIN
SELECT seq_Actuacions.NEXTVAL INTO :NEW.IdActuacio
FROM DUAL;
END NouIdActuacio;

------------------
--Agents
------------------
CREATE SEQUENCE seq_Agents 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdAgent
BEFORE INSERT ON Agents
FOR EACH ROW
BEGIN
SELECT seq_Agents.NEXTVAL INTO :NEW.IdAgent
FROM DUAL;
END NouIdAgent;

------------------
--Centres
------------------
CREATE SEQUENCE seq_Centres 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdCentre
BEFORE INSERT ON Centres
FOR EACH ROW
BEGIN
SELECT seq_Centres.NEXTVAL INTO :NEW.IdCentre
FROM DUAL;
END NouIdCentre;

------------------
--Clients
------------------
CREATE SEQUENCE seq_Clients 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdClient
BEFORE INSERT ON Clients
FOR EACH ROW
BEGIN
SELECT seq_Clients.NEXTVAL INTO :NEW.IdClient
FROM DUAL;
END NouIdClient;

------------------
--Estats
------------------
CREATE SEQUENCE seq_Estats 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdEstat
BEFORE INSERT ON Estats
FOR EACH ROW
BEGIN
SELECT seq_Estats.NEXTVAL INTO :NEW.IdEstat
FROM DUAL;
END NouIdEstat;

------------------
--Garanties
------------------
CREATE SEQUENCE seq_Garanties 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdGarantia
BEFORE INSERT ON Garanties
FOR EACH ROW
BEGIN
SELECT seq_Garanties.NEXTVAL INTO :NEW.IdGarantia
FROM DUAL;
END NouIdGarantia;

------------------
--Incidencies
------------------
CREATE SEQUENCE seq_Incidencies 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdIncidencia
BEFORE INSERT ON Incidencies
FOR EACH ROW
BEGIN
SELECT seq_Incidencies.NEXTVAL INTO :NEW.IdIncidencia
FROM DUAL;
END NouIdIncidencia;

------------------
--Localitats
------------------
CREATE SEQUENCE seq_Localitats 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdLocalitat
BEFORE INSERT ON Localitats
FOR EACH ROW
BEGIN
SELECT seq_Localitats.NEXTVAL INTO :NEW.IdLocalitat
FROM DUAL;
END NouIdLocalitat;

------------------
--LogExecucio
------------------
CREATE SEQUENCE seq_LogExecucio 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdExecucio
BEFORE INSERT ON LogExecucio
FOR EACH ROW
BEGIN
SELECT seq_LogExecucio.NEXTVAL INTO :NEW.IdExecucio
FROM DUAL;
END NouIdExecucio;

------------------
--Paisos
------------------
CREATE SEQUENCE seq_Paisos 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdPais
BEFORE INSERT ON Paisos
FOR EACH ROW
BEGIN
SELECT seq_Paisos.NEXTVAL INTO :NEW.IdPais
FROM DUAL;
END NouIdPais;

------------------
--Perfils
------------------
CREATE SEQUENCE seq_Perfils
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdPerfil
BEFORE INSERT ON Perfils
FOR EACH ROW
BEGIN
SELECT seq_Perfils.NEXTVAL INTO :NEW.IdPerfil
FROM DUAL;
END NouIdPerfil;

------------------
--Permisos
------------------
CREATE SEQUENCE seq_Permisos 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdPermis
BEFORE INSERT ON Permisos
FOR EACH ROW
BEGIN
SELECT seq_Permisos.NEXTVAL INTO :NEW.IdPermis
FROM DUAL;
END NouIdPermis;

------------------
--Prioritats
------------------
CREATE SEQUENCE seq_Prioritats
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdPrioritat
BEFORE INSERT ON Prioritats
FOR EACH ROW
BEGIN
SELECT seq_Prioritats.NEXTVAL INTO :NEW.IdPrioritat
FROM DUAL;
END NouIdPrioritat;

------------------
--Productes
------------------
CREATE SEQUENCE seq_Productes 
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdProducte
BEFORE INSERT ON Productes
FOR EACH ROW
BEGIN
SELECT seq_Productes.NEXTVAL INTO :NEW.IdProducte
FROM DUAL;
END NouIdProducte;

------------------
--Provincies
------------------
CREATE SEQUENCE seq_Provincies
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdProvincia
BEFORE INSERT ON Provincies
FOR EACH ROW
BEGIN
SELECT seq_Provincies.NEXTVAL INTO :NEW.IdProvincia
FROM DUAL;
END NouIdProvincia;

------------------
--TipusActuacio
------------------
CREATE SEQUENCE seq_TipusActuacio
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdTipusActuacio
BEFORE INSERT ON TipusActuacio
FOR EACH ROW
BEGIN
SELECT seq_TipusActuacio.NEXTVAL INTO :NEW.IdTipusActuacio
FROM DUAL;
END NouIdTipusActuacio;

------------------
--TipusIncidencia
------------------
CREATE SEQUENCE seq_TipusIncidencia
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdTipusIncidencia
BEFORE INSERT ON TipusIncidencia
FOR EACH ROW
BEGIN
SELECT seq_TipusIncidencia.NEXTVAL INTO :NEW.IdTipusIncidencia
FROM DUAL;
END NouIdTipusIncidencia;

------------------
--TipusProducte
------------------
CREATE SEQUENCE seq_TipusProducte
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdTipusProducte
BEFORE INSERT ON TipusProducte
FOR EACH ROW
BEGIN
SELECT seq_TipusProducte.NEXTVAL INTO :NEW.IdTipusProducte
FROM DUAL;
END NouIdTipusProducte;

------------------
--Usuaris
------------------
CREATE SEQUENCE seq_Usuaris
INCREMENT BY 1
START WITH 1;

CREATE OR REPLACE TRIGGER NouIdUsuari
BEFORE INSERT ON Usuaris
FOR EACH ROW
BEGIN
SELECT seq_Usuaris.NEXTVAL INTO :NEW.IdUsuari
FROM DUAL;
END NouIdUsuari;
